<?php

/**
 * Project:     Collator: the Question Writer results collator
 * File:        parse_xml.inc.php
 *
 * Copyright 2008 Central Question Ltd.
 * 
 * This application is provided as an extension of the 
 * Question Writer desktop software. Where you hold a valid, paid-for
 * license for the Question Writer desktop software, you are hereby 
 * granted a license to use and modify this application for personal use
 * and use internal to your organization. All other rights are reserved. 
 * 
 * This application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * @link http://www.questionwriter.com/
 * @copyright 2008 Central Question Ltd.
 * @author Alexander McCabe 
 * @package Collator
 */


$quizreference="";//VARIABLE TO CAPTURE THE QUIZ REFERENCE NO...
$quesfound="";//VARIABLE TO IDENTIFY THE BEGINNING AND END OF THE QUESTION..
$getanswer="";//VARIABLE TO IDENTIFY THE RESPONSE FOR THE PARTICULAR QUESTION..
$getscore="";//VARIABLE TO IDENTIFY THE SCORE FOR THE PARTICULAR QUESTION...
$Aanswers[]="";//ARRAY TO STORE THE RESULTSET OF THE QUESTIONS AND ANSWERS...
$currenttag="";
$getduration="";//VARIABLE TO IDENTIFY THE DURATION FOR THE PARTICULAR QUESTION...
$getsection="";//VARIABLE TO IDENTIFY THE SECTION BEGINNING AND ENDING ...
$getquesref="";//VARIABLE TO IDENTIFY THE QUESTION REFERENCE NO.
$answerseq=0;//VARIABLE TO COUNT THE SEQUENCE OF QUESTIONS...
$getcalculations="";//VARIABLE TO IDENTIFY THE CALCULATIONS FOR THE QUIZ..
$Ascores="";//ARRAY VARIABLE TO STORE THE CALCULATIONS FOR THE QUIZ...
$getcalc="";//VARIABLE TO DEFINE WHICH PART OF THE SCORE TO GET...
$system_info="";//VARIABLE TO DEFINE BEGINNING OF SYSTEM INFORMATION GENERIC IDENTIFIER TAG...
$sysinfo="";//VARIABLE TO IDENTIFY SYS INFO VARIABLE AVAILABLE...
$getsysinfo="";//VARIABLE TO IDENTIFY AVAILABILITY OF SYSTEM DATA...
$newsysvariable="";//VARIABLE TO DEFINE THE NEW SYSTEM VARIABLE..
$is_candidate="";//VARIABLE TO DEFINE THE CANDIDATE NAME...
$totaltime=0;//VARIABLE TO GET THE TOTAL TIME FOR THE QUIZ...
$gettotaltime="";//VARIABLE TO IDENTIFY THE TOTAL TIME FOR THE QUIZ...
$userdata1="";
$userdata2="";
$userdata3="";
$userdata4="";
$userdata5="";
$newresponselabel="";
$is_candidate2="";//VARIABLE TO DEFINE THE CANDIDATE NAME...
$is_candidate3="";//VARIABLE TO DEFINE THE CANDIDATE NAME...
$is_candidate4="";//VARIABLE TO DEFINE THE CANDIDATE NAME...
$is_candidate5="";//VARIABLE TO DEFINE THE CANDIDATE NAME...
//Setup the XML parser
if (! ($xmlparser = xml_parser_create()) ){
	returnError("Cannot create parser");
}


function start_tag($parser, $name, $attribs) 
{

		global $quesfound,$getanswer,$answerseq,$Aanswers,$getscore,$currenttag,$getduration,$getsection,$getquesref,$quizreference,$getcalculations,$Ascores,$getcalc,$system_info,$sysinfo,$getsysinfo,$newsysvariable,$is_candidate,$totaltime,$gettotaltime,$newresponselabel,$is_candidate2,$is_candidate3,$is_candidate4,$is_candidate5;

        $currenttag=$name;
        $newresponselabel="yes";

		//GETTING QUIZ REFERENCE NO..
        if($name=="ASSESSMENT_RESULT")
		{
			$quizreference=$attribs["IDENT_REF"];
		}
		
		//GETTING SECTION REFERENCE NO...
        if($name=="SECTION_RESULT")
		{ 
			$getsection=$attribs["IDENT_REF"]; 
			//error_log($getsection);
			//$getsection=strrchr($getsection,"#");
			//error_log($getsection); 
			if($getsection=="")
			{
				$getsection="Main Section";
			}
		}
		//GETTING QUESTION REFERENCE NO...
        if($quesfound=="yes"&&$name=="RESPONSE"&&(array_key_exists("IDENT_REF", $attribs)))
        {
           $getquesref=$attribs["IDENT_REF"];
           $getquesref=strrchr($getquesref,"#");
           $Aanswers[$answerseq][5]=$getquesref;
        }
		//IDENTIFYING CANDIDATE NAME..
        if($name=="RESPONSE"){
        	if($attribs["IDENT_REF"]=="Candidate"){
				$is_candidate="yes";
			}else if($attribs["IDENT_REF"]=="CandidateData2"){
				$is_candidate2="yes";
			}else if($attribs["IDENT_REF"]=="CandidateData3"){
				$is_candidate3="yes";
			}else if($attribs["IDENT_REF"]=="CandidateData4"){
				$is_candidate4="yes";
			}else if($attribs["IDENT_REF"]=="CandidateData5"){
				$is_candidate5="yes";
			}
        }

		//GETTING QUESTION NAME AND IDENTIFYING THE QUESTION BOUNDARIES...
        if($name=="ITEM_RESULT")
        {
        	$findme="Question";
            if((stristr($attribs["IDENT_REF"],$findme))&&!(stristr($attribs["IDENT_REF"],"FB:")))
            {
              $quesfound="yes";
              $Aanswers[$answerseq][1]=$attribs["IDENT_REF"];
              $Aanswers[$answerseq][0]=$getsection;
            }
        }
		//IDENTIFYING RESPONSE VALUE FOR THE QUESTION ...
        if($quesfound=="yes"&&$name=="RESPONSE_VALUE")
		{
			$getanswer="yes";
		}

 		//IDENTIFYING SCORE FOR THE QUESTION...
        if($quesfound=="yes"&&$name=="SCORE")
		{ 
			$getscore="yes"; 
		}
		
		//IDENTIFYING DURATION TAKEN ON THE QUESTION...
        if($quesfound=="yes"&&$name=="DURATION")
		{ 
			$getduration="yes"; 
		}

		//GETTING AND IDENTIFYING THE RESULTS BOUNDARIES...
        if($name=="ITEM_RESULT"&&$attribs["IDENT_REF"]=="CalculationPage")
        {
              $getcalculations="yes";
        }
        if($getcalculations==="yes"&&$name="SCORE")
        {
          Switch ($attribs['VARNAME'])
          {
            Case "overallscore":
                $getcalc="OverAllScore";
                break;
            Case "totalpossiblescore":
                $getcalc="TotalPossibleScore";
                break;
            Case "percentagescore":
                $getcalc="PercentageScore";
                break;
            Case "percentagescorestring":
                $getcalc="PercentageScoreString";
                break;
            Case "percentagepass":
                $getcalc="PercentagePass";
                break;
            Case "passfail":
                $getcalc="PassFail";
                break;
          }
        }

		//GETTING AND IDENTIFYING SYSTEM DETAILS...
        if($name=="GENERIC_IDENTIFIER")
		{
			$system_info="yes";
		}
        if($system_info=="yes"&&$name=="TYPE_LABEL")
		{
			$sysinfo="yes";
		}
		//         if($sysinfo=="yes"&&$name=="IDENTIFIER_STRING"){$getsysinfo="yes";}
		//IDENTIFYING TOTAL TIME...
		/*if($name=="SECTION_RESULT"&&$attribs['IDENT_REF']=="quizReview")
		{
		  $gettotaltime="start";
		}
		if($name=="DURATION"&&$gettotaltime=="yes")
		{
			$gettotaltime="getit";
		}*/
}


function end_tag($parser, $name) 
{
		global $quesfound,$getanswer,$answerseq,$Aanswers,$getscore,$currenttag,$getduration,$getsection,$getquesref,$quizreference,$getcalculations,$Ascores,$getcalc,$system_info,$sysinfo,$getsysinfo,$newsysvariable,$is_candidate,$totaltime,$gettotaltime,$newresponselabel,$is_candidate2,$is_candidate3,$is_candidate4,$is_candidate5;
		//DEFINING END OF THE QUESTION...
		if($quesfound=="yes"&&$name=="ITEM_RESULT")
		{
			$quesfound=""; 
			$getanswer=""; 
			$getscore=""; 
			$answerseq++;
		}
		
		//DEFINING END OF THE CALCULATIONS AREA...
		if($getcalculations=="yes"&&$name=="ITEM_RESULT")
		{
			$getcalculations=""; 
		}
		
		//Reset is candidate
		$is_candidate="";
		$is_candidate2="";
		$is_candidate3="";
		$is_candidate4="";
		$is_candidate5="";
		
		
		/*if($name=="SECTION_RESULT"&&$gettotaltime=="start")
		{
			$gettotaltime="yes";
		}*/
}

function tag_contents($parser, $data) 
{
		//error_log($data);
		
		global $quesfound,$getanswer,$answerseq,$Aanswers,$getscore,$currenttag,$getduration,$getsection,$getquesref,$quizreference,$getcalculations,$Ascores,$getcalc,$system_info,$sysinfo,$getsysinfo,$newsysvariable,$is_candidate,$totaltime,$gettotaltime,$userdata1,$userdata2,$userdata3,$userdata4,$userdata5,$newresponselabel,$is_candidate2,$is_candidate3,$is_candidate4,$is_candidate5;
		
		//GETTING RESPONSE DATA FOR THE QUESTION...
		if($getanswer=="yes"&&$currenttag=="RESPONSE_VALUE")
		{
			if(array_key_exists("2",$Aanswers[$answerseq]))
			{
				if($newresponselabel=="yes"){
					//concatenating multiple response values
					$Aanswers[$answerseq][2].=" ".$data;
				}else{
					//concatenating a single response value
					$Aanswers[$answerseq][2].=$data;
				}
			}
			else
			{
				//First part and first reponse label
				$Aanswers[$answerseq][2]=$data;
			}
			$newresponselabel="";
				
			if(strpos($Aanswers[$answerseq][1],"# Data1")==9){
				$userdata1=$Aanswers[$answerseq][2];
			}else if(strpos($Aanswers[$answerseq][1],"# Data2")==9){
				$userdata2=$Aanswers[$answerseq][2];
			}else if(strpos($Aanswers[$answerseq][1],"# Data3")==9){
				$userdata3=$Aanswers[$answerseq][2];
			}else if(strpos($Aanswers[$answerseq][1],"# Data4")==9){
				$userdata4=$Aanswers[$answerseq][2];
			}else if(strpos($Aanswers[$answerseq][1],"# Data5")==9){
				$userdata5=$Aanswers[$answerseq][2];
			}
		}
		
		//GETTING SCORE DATA FOR THE QUESTION...
		if($getscore=="yes"&&$currenttag=="SCORE"){ $Aanswers[$answerseq][3]=$data;}
		//GETTING DURATION DATA FOR THE QUESTION
		if($getscore=="yes"&&$currenttag=="DURATION"){
			$Aanswers[$answerseq][4]=$data;
			$totaltime=$totaltime+trim($data,"PS");
		}
		
		//GETTING OVERALLSCORE DATA INTO ARRAY
		if($getcalculations=="yes"&&$currenttag=="SCORE"){ $Ascores[$getcalc]=$data; $getcalc="";}
		
		//GETTING SYSINFO VARIABLE
		if($sysinfo=="yes"&&$currenttag=="TYPE_LABEL"){$newsysvariable=str_replace(" ","",$data); }
		//GETTING SYSTEM INFORMATION
		 if(($sysinfo=="yes")&&($currenttag=="IDENTIFIER_STRING")){
		 	//Avoiding using variables names from untrusted XML
		 	if($newsysvariable=="SystemLanguage"){
		 		$Ascores["SystemLanguage"]=$data;	
		 	}else if($newsysvariable=="OS"){
		 		$Ascores["OS"]=$data;	
		 	}else if($newsysvariable=="ScreenRes"){
		 		$Ascores["ScreenRes"]=$data;	
		 	}else if($newsysvariable=="Version"){
		 		$Ascores["Version"]=$data;	
		 	}else if($newsysvariable=="ClientTime"){
		 		$Ascores["ClientTime"]=$data;	
		 	}else if($newsysvariable=="SourceURL"){
		 		//This value can be split because of special characters, so we are concatenating
		 		$Ascores["SourceURL"]=$Ascores["SourceURL"].$data;	
		 	}else if($newsysvariable=="SourceID"){
		 		if ($Ascores['Candidate']==""){
					$Ascores['Candidate']=$data;
				}else{
					$Ascores['Candidate'] = $Ascores['Candidate']." (".$data.")";
				}
		 	} 	
		 	$sysinfo=""; $system_info="";
		 }
		//GETTING CANDIDATE NAME...
		if($is_candidate=="yes"){
			//This value can be split because of special characters, so we are concatenating
			$Ascores['Candidate']=$Ascores['Candidate'].$data;
		}else if($is_candidate2=="yes"){
			//This value can be split because of special characters, so we are concatenating
			$userdata2=$userdata2.$data;
		}else if($is_candidate3=="yes"){
			//This value can be split because of special characters, so we are concatenating
			$userdata3=$userdata3.$data;
		}else if($is_candidate4=="yes"){
			//This value can be split because of special characters, so we are concatenating
			$userdata4=$userdata4.$data;
		}else if($is_candidate5=="yes"){
			//This value can be split because of special characters, so we are concatenating
			$userdata5=$userdata5.$data;
		}
		
		//GETTING TOTAL TIME..
		//if($gettotaltime=="getit"){$totaltime=$data; $gettotaltime="";}
}

xml_set_element_handler($xmlparser, "start_tag", "end_tag");
xml_set_character_data_handler($xmlparser, "tag_contents");
?>